<template>
	<div>

		<div class="section--stream__video">

			<template>
				<div class="stream__video">

					<video id="player" v-if="content.src">
						<source v-if="content.src.mp4" :src="content.src.mp4" type="video/mp4" />
						<source v-if="content.src.webm" :src="content.src.webm" type="video/webm" />
					</video>

					<div v-else id="player" data-plyr-provider="youtube" :data-plyr-embed-id="content.youtube_id"></div>

					<div class="stream__video__controls" v-if="isPlaying">
						<div class="stream__video__controls__live">Live</div>
						<div class="stream__video__controls__time">{{ awFormattedPlayTime }}</div>
					</div>
					<div class="stream__video__overlay" v-if="!isPlaying || isLoading">
						<div class="stream__video__loader" v-if="isLoading"></div>
						<va-button @click.native="connect" v-if="isLive && !isPlaying && !isLoading" text="Подключиться к трансляции" />

						<div class="stream__video__overlay__timer" v-if="isBefore && canShowNextStream && (untilNext.h > 0 || untilNext.m > 0 || untilNext.s > 0)">
							До старта осталось <div>{{ `${leadingZero(untilNext.h)}:${leadingZero(untilNext.m)}:${leadingZero(untilNext.s)}` }}</div>
						</div>

						<div class="stream__video__overlay__timer" v-else-if="!canShowNextStream">
							К сожалению, трансляция <div>завершена</div>
						</div>
					</div>

				</div>
			</template>
		</div>

		<div class="row">

			<div class="col-xl-8" v-if="comments_allowed">
				<h2 class="section--stream__speakers__title">Комментарии</h2>
				<div class="stream__comments" :class="{'stream__comments--empty': !comments.length, 'stream__comments--blocked': !isLive || needLogin}" v-chat-scroll ref="comments">

					<!-- Если трансляция не закончилась + пользователь не указал имя -->
					<div class="stream__comments__empty" v-if="needLogin">
						<emoji emoji="🖐🏻" />
						<div class="stream__comments__empty__title">Познакомимся?</div>
						<div class="stream__comments__empty__text">Если хочешь оставить комментарий, пожалуйста, укажи своё имя</div>
						<div class="stream__comments__empty__form">
							<input type="text" v-model="userModel.name" name="name" placeholder="Твоё имя">
							<input type="text" v-model="userModel.email" name="email" placeholder="Электронная почта">
							<button class="button button--size-xs" :disabled="!emailIsValid || !userModel.name" @click="saveUser">Войти</button>
						</div>
					</div>


					<!-- Hide all comments -->
					<div class="stream__comments__empty" v-else-if="!isLive">
						<emoji emoji="🤷🏻‍♂️" />
						<div class="stream__comments__empty__title">Трансляция {{ isBefore && canShowNextStream ? 'ещё не началась' : 'уже закончилась' }}</div>
						<div class="stream__comments__empty__text">{{ isBefore && canShowNextStream ? 'Как только она начнётся, можно будет отправить сюда свой комментарий...' : 'Будем рады видеть тебя в следующий раз' }}</div>
					</div>

					<!-- Если комментариев нет -->
					<div class="stream__comments__empty" v-else-if="!comments.length">
						<emoji emoji="🤷🏻‍♂️" />
						<div class="stream__comments__empty__title">Комментариев пока нет</div>
						<div class="stream__comments__empty__text">Как только они появятся, мы&nbsp;отобразим. Не&nbsp;забывай, никто не&nbsp;мешает тебе начать дискуссию...</div>
					</div>



					<div class="stream__comments__item" v-else v-for="(c,i) in comments" :key="i">
						<div class="stream__comments__item__avatar">{{ c.name.substr(0,1) }}</div>
						<div class="stream__comments__item__name">{{ c.name }}</div>
						<div class="stream__comments__item__text">{{ c.text }}</div>
					</div>
				</div>
				<div class="stream__comments__field" v-if="isLive && !needLogin">
					<input v-model="newComment" @keypress.enter="sendComment" type="text" placeholder="Комментарий...">
					<button @click="sendComment" :disabled="!isLive || !newComment.length" class="button button--size-xs">Отправить</button>
				</div>
			</div>

			<div class="col-xl-8" v-else>
				<div class="text-block section--stream__text" v-html="content.text" v-if="content.text"></div>
			</div>


			<div class="col-xl-4">
				<div class="section--stream__sidebar">
					<div class="section--stream__speakers">
						<h2 class="section--stream__speakers__title">Спикеры:</h2>

						<div class="section--stream__speaker">
							<img src="/valery.jpeg" alt="Валерий Алексеев" class="section--stream__speaker__photo">
							<div class="section--stream__speaker__name">Валерий Алексеев</div>
							<div class="section--stream__speaker__text">Дизайнер, руководитель Школы #VA</div>
							<div class="section--stream__speaker__socials">
								<a href="https://instagram.com/valery_alexeev" target="_blank">Instagram</a>
								<a href="https://youtube.com/va_promotion" target="_blank">YouTube</a>
								<a href="https://behance.net/valery-alexeev" target="_blank">Behance</a>
							</div>
						</div>
					</div>


					<div class="section--stream__links" v-if="content.links && content.links.length">
						<h2 class="section--stream__links__title">Ссылки:</h2>
						<ul>
							<li v-for="l, i in content.links" :key="i"><a target="_blank" :href="l.url">{{ l.title }}</a> — {{ l.text }}</li>
						</ul>
					</div>
				</div>
			</div>
		</div>

	</div>
</template>

<script>
import moment from 'moment-timezone';
import Plyr from "plyr";
import validate from "~/plugins/validate.js";

import Mixin from '../../BuilderBlockMixin.vue'
export default {
	mixins: [
		Mixin
	],
	data() {
		return {
			newComment: '',
			isLive: false,
			isBefore: false,
			isAfter: false,
			isAfterReset: false,
			now: moment(),

			secondsPlayed: 0,

			untilNext: {
				h: 0,
				m: 0,
				s: 0
			},

			isPlaying: false,
			isLoading: false,
			player: null,
			...this.content.autowebinar,
			comments: [],

			user: {},
			userModel: {
				email: null,
				name: null
			},
			userCarrotConversation: null,
			canShowNextStream: null
		}
	},


	computed: {

		emailIsValid() {
			return this.userModel && this.userModel.email && validate.email(this.userModel.email);
		},

		needLogin() {
			return !this.isAfter && (!this.user.name || !this.user.email);
		},

		carrotUserId() {
			return window.carrotquest && window.carrotquest.data && window.carrotquest.data.user && window.carrotquest.data.user.id ? window.carrotquest.data.user.id : false;
		},

		/**
		 * Next stream start
		 */
		awNextStart() {

			let now = moment(),
				nextStart = moment.tz(this.tz).set(this.startsAt);

			// Если NextStart в прошлом, увеличиваем на один день
			if (nextStart.isBefore(now)) {
				nextStart.add(1, 'day');
			}

			return nextStart;
		},

		/**
		 * Format watch time
		 */
		awFormattedPlayTime() {
			let d = this.secondsPlayed;
			let played = {
				h: Math.floor(d / 3600),
    			m: Math.floor(d % 3600 / 60),
    			s: Math.floor(d % 3600 % 60)
			};
			return played.h + ':' + (played.m > 9 ? played.m : '0' + played.m) + ':' + (played.s > 9 ? played.s : '0' + played.s);
		},

		commentsLocalStorageName() {
			return `userComments_${this.now.format('DDMMYYYY')}`;
		}
	},

	created() {
		this.updateStates();
		setInterval(() => {
			this.updateStates();
		}, 500);
	},

	mounted() {



		/**
		 * Create Local Storage placeholder for user comments
		 */
		if (!localStorage[this.commentsLocalStorageName]) {
			localStorage.setItem(this.commentsLocalStorageName, JSON.stringify({}));
		} else {
			this.autocomments = {
				...this.autocomments,
				...JSON.parse(localStorage.getItem(this.commentsLocalStorageName))
			};
		}

		/**
		 * Create Local Storage placeholder user data
		 */
		if (!localStorage['awUser']) {
			localStorage.setItem('awUser', JSON.stringify({}));
		} else {
			this.user = JSON.parse(localStorage.getItem('awUser'));
		}

		/**
		 * Create Local Storage Carrotquest Conversation
		 */
		if (localStorage['awCarrotConversation']) {
			this.userCarrotConversation = localStorage.getItem('awCarrotConversation');
		}

		if (this.player) {
			this.player.volume = 0;
		}

		this.updateComments();
		setTimeout(() => {
			this.scrollComments();
		}, 200);

		setInterval(() => {
			this.updateComments();
		}, 2000);




		this.player = new Plyr('#player', {
			controls: ['fullscreen'],
			loadSprite: false,
			clickToPlay: false,
			hideControls: false,
			autopause: false,
			keyboard: { focused: false, global: false }
		});


		// this.$refs.video.controls = false;
	},

	methods: {

		scrollComments() {
			this.$refs['comments'].scrollTop = this.$refs['comments'].scrollHeight;
		},

		leadingZero(v) {
			return v < 10 ? '0' + v : v;
		},

		saveUser() {
			if (!this.userModel.name || !this.userModel.email) {
				return;
			}
			localStorage.setItem('awUser', JSON.stringify(this.userModel));
			this.user = this.userModel;

			window.carrotquest.identify({'$name': this.userModel.name, '$email': this.userModel.email});
			setTimeout(() => {
				this.scrollComments();
			}, 200);
		},

		connect() {
			this.isLoading = true;

			this.player.on('playing', () => {
				this.isPlaying = true;
				setTimeout(() => {
					this.player.volume = 1;
				}, 1500);
				setTimeout(() => {
					this.isLoading = false;
				}, 3500);
			});

			this.player.play();
			this.player.currentTime = this.secondsPlayed;
		},

		updateStates() {

			let now = moment.tz(this.tz),
				startMoment = moment.tz(this.startsAt, this.tz),
				endMoment = moment.tz(this.tz).set(this.startsAt).add(this.length).add(4, 'second'),
				nextAllowedStart = endMoment.clone().subtract(endMoment.isSame(now, 'day') ? 1 : 0, 'day').add(this.resetAfter);

			this.isLive =			now.isBetween(startMoment, endMoment);
			this.isBefore =			now.isBefore(startMoment);
			this.isAfter =			now.isAfter(endMoment);
			this.canShowNextStream =	nextAllowedStart.isBefore(now);


			this.isAfterReset =		now.isAfter(endMoment.add(this.resetAfter));
			this.secondsPlayed =	this.isLive ? Math.floor(now.diff(startMoment) / 1000) : 0;

			let d = Math.floor(this.awNextStart.diff(now) / 1000);
			this.untilNext = this.isBefore ? {
				h: Math.floor(d / 3600),
    			m: Math.floor(d % 3600 / 60),
    			s: Math.floor(d % 3600 % 60)
			} : null;
		},


		updateComments() {
			var comments = this.autocomments;

			for (var timestamp in comments) {
				var comment = this.autocomments[timestamp],
					ts = timestamp.split(":"),
					seconds = (+ts[0]) * 60 * 60 + (+ts[1]) * 60 + (+ts[2]);

				if (this.secondsPlayed >= seconds) {
					this.$delete(this.autocomments, timestamp);
					this.comments.push(comment);
				}
			}

		},


		sendComment() {
			if (!this.newComment.length) {
				return;
			}

			var comment = {
				name: this.user.name,
				text: this.newComment
			};

			this.comments.push(comment);

			// Сохраняем комментарий пользователя в ЛС
			var lsComments = JSON.parse(localStorage.getItem(this.commentsLocalStorageName));
			lsComments[this.awFormattedPlayTime] = comment;
			localStorage.setItem(this.commentsLocalStorageName, JSON.stringify(lsComments));

			// обнуляем поле коммента
			this.newComment = '';


			// Отправляем в CarrotQuest

			// Если открыт диалог
			if (this.carrotUserId) {
				if (this.userCarrotConversation) {
					this.$axios.post(`https://api.carrotquest.io/v1/conversations/${this.userCarrotConversation}/reply?auth_token=app.16921.45c5d18d450b1d4266828ae31fb2e96b28ba15ac7ddd6909&from_user=${this.carrotUserId}&body=${encodeURIComponent(comment.text)}`);
				} else {

					var url = `https://api.carrotquest.io/v1/users/${this.carrotUserId}/startconversation?auth_token=app.16921.45c5d18d450b1d4266828ae31fb2e96b28ba15ac7ddd6909&body=${encodeURIComponent(comment.text)}`;

					var xhr = new XMLHttpRequest();
					xhr.open("POST", url);

					xhr.setRequestHeader("Content-Type", "application/json");
					xhr.setRequestHeader("Content-Length", "0");

					xhr.onreadystatechange = () => {
					if (xhr.readyState === 4) {
						console.log(xhr.responseText);
						var result = xhr.responseText.replace(/([\[:])?(\d+)([,\}\]])/g, "$1\"$2\"$3");
						var result = JSON.parse(result);
						this.userCarrotConversation = result.data.id;
						localStorage.setItem('awCarrotConversation', result.data.id);
					}};

					xhr.send();
				}
			}



		}
	}
}
</script>

<style lang="scss">
@import "~/assets/scss/layouts/live";
</style>
